#!/bin/bash

# GPIO PIN setup for input
# ver. 20121007


PIN="$1" # pin number


if [ $# -lt 1 ]; then
  echo 1>&2 "$0: not enough arguments"
  echo 1>&2 "$0: usage: "$0" [pin]"
  exit 2
elif [ $# -gt 1 ]; then
  echo 1>&2 "$0: too many arguments"
  echo 1>&2 "$0: usage: "$0" [pin]"
fi

if [ ! -f "/sys/class/gpio/gpio"$PIN"/direction" ]; then # if port was not exported then make so wich creates this dir
   
echo "$PIN" > /sys/class/gpio/export # set up of pin

fi

echo "in" > /sys/class/gpio/gpio"$PIN"/direction # set the pin in input mode
cat /sys/class/gpio/gpio"$PIN"/value
