#!/bin/bash

# bassplay front-end for GPIO button control
# version 1.1 LED control implemented


# GPIO11 - play
# GPIO9 - stop
# GPIO10 - next song
# GPIO22 - previous song

# GPIO02 - player ready
# GPIO03 - play led
# GPIO04 - stop led
# GPIO17 - unused

PLAYERBIN="/usr/local/bin/basstest" # binary file of the player

SONGFILE=""	# path to the song to be played
START_PLAYER="false"   # defines whether process of player's start should be started (not desirable if runs already)
PATH_MOD="/files/music"
PLAYLIST="/tmp/playlist"
PLAYLIST_RECENT_LINE="1"
PLAYLIST_LASTLINE="0"

start_play ()
{

"$PLAYERBIN" "$PATH_MOD"/"$SONGFILE" &

}

stop_play ()

{

killall "$PLAYERBIN"
sleep 0.1

}

playlist_next ()

{

if [ "$PLAYLIST_RECENT_LINE" -eq  "$PLAYLIST_LASTLINE" ]
then
PLAYLIST_RECENT_LINE="1"
else
PLAYLIST_RECENT_LINE=$[$PLAYLIST_RECENT_LINE+1]
fi

}

playlist_previous ()

{

if [ "$PLAYLIST_RECENT_LINE" -eq  1 ]
then
PLAYLIST_RECENT_LINE="$PLAYLIST_LASTLINE"  # if the playlist is on begining, then jump in the last line (end)
else
PLAYLIST_RECENT_LINE=$[$PLAYLIST_RECENT_LINE-1] # previous song (line in the list)
fi

}

output_pins_init ()

{

gpout.sh 2 0
gpout.sh 3 0
gpout.sh 4 0
gpout.sh 17 0

}


### [ INIT OF OUTPUT PINS (LEDS) ###
output_pins_init

#### [ PLAYLIST ] ####
ls -1 "$PATH_MOD" > "$PLAYLIST" #creates playlist
PLAYLIST_LASTLINE=`cat "$PLAYLIST" | wc -l` #defines its last line (song) to start over when reaches end

### [ LED READY SET ON ] ###

gpout.sh 2 1

#### [ CONTROL ] ####
while true     # infinite loop reading/listing playlist
do

SONGFILE=`cat "$PLAYLIST" | sed -n "$PLAYLIST_RECENT_LINE"p` # process filename located on particular line
	
				#infinite loop to read pin values and execute/stop player
				# play/stop loop
				while true 
				do

				# START
				[ "`gpin.sh 11`" = "0" ] && START_PLAYER="true" # if set then player will be started
				if $START_PLAYER 
				then  start_play && gpout.sh 3 1 &&  gpout.sh 4 0 # start player , enable play led disable stop led
				sleep 0.1	# delay to avoid driver crash if invocated too earl after being stopped
				START_PLAYER="false" # new song is being played - returning value in false
				fi
				#STOP
				[ "`gpin.sh 9`" = "0" ] && stop_play && sleep 0.1 &&  gpout.sh 4 1 && gpout.sh 3 0  # stop player , disable play led enable stop led
				#NEXT SONG
				[ "`gpin.sh 10`" = "0" ] && stop_play && sleep 0.1 && START_PLAYER="true" && playlist_next && break  # next song -  kills player and exits play/stop loop 
				#PREVIOUS SONG
				[ "`gpin.sh 22`" = "0" ] && stop_play && sleep 0.1 && START_PLAYER="true" && playlist_previous && break  # previous song -  kills player and exits play/stop loop

				done

done
